Index: gcc/testsuite/gcc.c-torture/execute/pr56866.c
===================================================================
--- gcc/testsuite/gcc.c-torture/execute/pr56866.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.c-torture/execute/pr56866.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,45 @@
+/* PR target/56866 */
+
+int
+main ()
+{
+#if __CHAR_BIT__ == 8 && __SIZEOF_LONG_LONG__ == 8 && __SIZEOF_INT__ == 4 && __SIZEOF_SHORT__ == 2
+  unsigned long long wq[256], rq[256];
+  unsigned int wi[256], ri[256];
+  unsigned short ws[256], rs[256];
+  unsigned char wc[256], rc[256];
+  int t;
+
+  __builtin_memset (wq, 0, sizeof wq);
+  __builtin_memset (wi, 0, sizeof wi);
+  __builtin_memset (ws, 0, sizeof ws);
+  __builtin_memset (wc, 0, sizeof wc);
+  wq[0] = 0x0123456789abcdefULL;
+  wi[0] = 0x01234567;
+  ws[0] = 0x4567;
+  wc[0] = 0x73;
+
+  asm volatile ("" : : "g" (wq), "g" (wi), "g" (ws), "g" (wc) : "memory");
+
+  for (t = 0; t < 256; ++t)
+    rq[t] = (wq[t] >> 8) | (wq[t] << (sizeof (wq[0]) * __CHAR_BIT__ - 8));
+  for (t = 0; t < 256; ++t)
+    ri[t] = (wi[t] >> 8) | (wi[t] << (sizeof (wi[0]) * __CHAR_BIT__ - 8));
+  for (t = 0; t < 256; ++t)
+    rs[t] = (ws[t] >> 9) | (ws[t] << (sizeof (ws[0]) * __CHAR_BIT__ - 9));
+  for (t = 0; t < 256; ++t)
+    rc[t] = (wc[t] >> 5) | (wc[t] << (sizeof (wc[0]) * __CHAR_BIT__ - 5));
+
+  asm volatile ("" : : "g" (rq), "g" (ri), "g" (rs), "g" (rc) : "memory");
+
+  if (rq[0] != 0xef0123456789abcdULL || rq[1])
+    __builtin_abort ();
+  if (ri[0] != 0x67012345 || ri[1])
+    __builtin_abort ();
+  if (rs[0] != 0xb3a2 || rs[1])
+    __builtin_abort ();
+  if (rc[0] != 0x9b || rc[1])
+    __builtin_abort ();
+#endif
+  return 0;
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr56984.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr56984.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr56984.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,9 @@
+/* PR tree-optimization/56984 */
+
+int
+foo (int x)
+{
+  if ((x >> 31) < -1)
+    x++;
+  return x;
+}
Index: gcc/testsuite/gcc.c-torture/compile/pr56745.c
===================================================================
--- gcc/testsuite/gcc.c-torture/compile/pr56745.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.c-torture/compile/pr56745.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,15 @@
+/* PR rtl-optimization/56745 */
+
+unsigned char a[6];
+
+void
+foo ()
+{
+  int i;
+  for (i = 5; i >= 0; i++)
+    {
+      if (++a[i] != 0)
+	break;
+      ++a[i];
+    }
+}
Index: gcc/testsuite/gnat.dg/specs/array3.ads
===================================================================
--- gcc/testsuite/gnat.dg/specs/array3.ads	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gnat.dg/specs/array3.ads	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,18 @@
+-- PR middle-end/56474
+-- Reported by Pavel Zhukov <pavel@zhukoff.net>
+
+-- { dg-do compile }
+
+with Ada.Streams;
+
+package Array3 is
+
+   use type Ada.Streams.Stream_Element_Offset;
+
+   type Vector (Size : Ada.Streams.Stream_Element_Offset) is record
+      Value : Ada.Streams.Stream_Element_Array (0 .. Size);
+   end record;
+
+   Empty_Vector : Vector (-1);
+
+end Array3;
Index: gcc/testsuite/gcc.dg/pr56890-2.c
===================================================================
--- gcc/testsuite/gcc.dg/pr56890-2.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/pr56890-2.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,19 @@
+/* PR target/56890 */
+/* Reported by Rainer Jung <rainer.jung@kippdata.de> */
+
+/* { dg-do assemble } */
+/* { dg-options "-O" } */
+
+unsigned int buggy(unsigned int min, unsigned int max)
+{
+    unsigned int number;
+    if (max < 16384) {
+        unsigned short num16;
+        num16 = min + (long) ((double) (max - min + 1.0) * (num16 / (65535 + 1.0)));
+        return num16;
+    }
+    else {
+        (number) = min + (long) ((double) (max - min + 1.0) * (number / (4294967295U + 1.0)));
+    }
+    return number;
+}
Index: gcc/testsuite/gcc.dg/pr57300.c
===================================================================
--- gcc/testsuite/gcc.dg/pr57300.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/pr57300.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,21 @@
+/* PR rtl-optimization/57300 */
+/* { dg-do run } */
+/* { dg-options "-O3" } */
+/* { dg-additional-options "-msse2" { target sse2_runtime } } */
+
+extern void abort (void);
+int a, b, d[10];
+long long c;
+
+int
+main ()
+{
+  int e;
+  for (e = 0; e < 10; e++)
+    d[e] = 1;
+  if (d[0])
+    c = a = (b == 0 || 1 % b);
+  if (a != 1)
+    abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/pr57104.c
===================================================================
--- gcc/testsuite/gcc.dg/pr57104.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/pr57104.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,12 @@
+/* PR tree-optimization/57104 */
+/* { dg-do compile { target { x86_64-*-linux* && lp64 } } } */
+/* { dg-options "-fsanitize=thread" } */
+
+register int r asm ("r14");
+int v;
+
+int
+foo (void)
+{
+  return r + v;
+}
Index: gcc/testsuite/gcc.dg/strlenopt-23.c
===================================================================
--- gcc/testsuite/gcc.dg/strlenopt-23.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/strlenopt-23.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,15 @@
+/* PR tree-optimization/57230 */
+/* { dg-do run } */
+/* { dg-options "-O2" } */
+
+#include "strlenopt.h"
+
+int
+main ()
+{
+  char p[] = "hello world";
+  p[0] = (char) (strlen (p) - 1);
+  if (strlen (p) != 11)
+    abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/pr56847.c
===================================================================
--- gcc/testsuite/gcc.dg/pr56847.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/pr56847.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,12 @@
+/* PR rtl-optimization/56847 */
+/* { dg-do compile { target pie } } */
+/* { dg-options "-O2 -fpie" } */
+
+struct S { long int a, b; } e;
+__thread struct S s;
+
+void
+foo (void)
+{
+  s = e;
+}
Index: gcc/testsuite/gcc.dg/pr56992.c
===================================================================
--- gcc/testsuite/gcc.dg/pr56992.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/pr56992.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,18 @@
+/* PR rtl-optimization/56992 */
+/* { dg-do compile } */
+/* { dg-options "-Og -g" } */
+
+inline int
+foo (const char *x)
+{
+  return __builtin_strlen (x);
+}
+
+int
+bar (const char *x, unsigned int *y)
+{
+  unsigned int l = foo (x);
+  if (l > 15)
+    l = 15;
+  *y = l;
+}
Index: gcc/testsuite/gcc.dg/pr57184.c
===================================================================
--- gcc/testsuite/gcc.dg/pr57184.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/pr57184.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,13 @@
+/* PR debug/57184 */
+/* { dg-do compile } */
+/* { dg-options "-O2 -g" } */
+
+struct S {};
+void bar (struct S *const);
+static struct S *const c = &(struct S) {};
+
+void
+foo (void)
+{
+  bar (c);
+}
Index: gcc/testsuite/gcc.dg/uninit-pred-5_a.c
===================================================================
--- gcc/testsuite/gcc.dg/uninit-pred-5_a.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.dg/uninit-pred-5_a.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -6,8 +6,9 @@
 int blah(int);
 void t(int);
 
+static int
 __attribute__((always_inline)) 
-int foo (int n, int* v, int r)
+foo (int n, int* v, int r)
 {
   int flag = 0;
   if (r > n)
Index: gcc/testsuite/gcc.dg/noreturn-8.c
===================================================================
--- gcc/testsuite/gcc.dg/noreturn-8.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.dg/noreturn-8.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,4 +1,4 @@
-/* { dg-do run } */
+/* { dg-do run { target nonpic } } */
 /* { dg-options "-O2" } */
 void exit (int);
 void noreturn_autodetection_failed ();
Index: gcc/testsuite/gcc.dg/pr57149.c
===================================================================
--- gcc/testsuite/gcc.dg/pr57149.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/pr57149.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,50 @@
+/* PR tree-optimization/57149 */
+/* { dg-do compile } */
+/* { dg-options "-Os -Wuninitialized" } */
+
+struct A { struct A *a, *b; };
+struct D { struct A e; };
+struct E { unsigned char f; struct { struct A e; } g; };
+struct F { struct E i[32]; };
+
+extern int fn0 (void);
+extern int fn1 (struct E *, struct D *);
+
+static inline __attribute__ ((always_inline)) int
+fn2 (const struct A *x)
+{
+  return x->a == x;
+}
+
+static int
+fn3 (struct E *x)
+{
+  struct D *l, *m;
+  int retval = retval;
+  if (fn2 (&x->g.e))
+    return 0;
+  for (l = (struct D *) x->g.e.a, m = (struct D *) l->e.a;
+       &l->e != &x->g.e;
+       l = m, m = (struct D *) m->e.a)
+    retval = fn1 (x, l);
+  return retval;
+}
+
+void
+fn4 (struct F *x, unsigned k)
+{
+  unsigned i;
+  for (i = 0; i < k; i++)
+    {
+      struct E *y = &x->i[i];
+      int err = -22;
+      err = fn3 (y);
+      if (y->f == 0)
+	{
+	  if (err > 0)
+	    err = fn0 ();
+	  if (err < 0)	/* { dg-bogus "may be used uninitialized in this function" } */
+	    fn0 ();
+	}
+    }
+}
Index: gcc/testsuite/gcc.dg/autopar/pr57103.c
===================================================================
--- gcc/testsuite/gcc.dg/autopar/pr57103.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/autopar/pr57103.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,19 @@
+/* { dg-do compile } */
+/* { dg-options "-O -ftree-parallelize-loops=4" } */
+
+int d[1024];
+
+static inline int foo (void)
+{
+  int s = 0;
+  int i = 0;
+  for (; i < 1024; i++)
+    s += d[i];
+  return s;
+}
+
+void bar (void)
+{
+  if (foo ())
+    __builtin_abort ();
+}
Index: gcc/testsuite/gcc.dg/autopar/pr57185.c
===================================================================
--- gcc/testsuite/gcc.dg/autopar/pr57185.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/autopar/pr57185.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,29 @@
+/* { dg-do compile } */
+/* { dg-options "-O3 -ftree-parallelize-loops=2 -fipa-pta" } */
+
+int a, b;
+int *d;
+void f(void)
+{
+  int c;
+  b %= 1;
+
+  if(1 - (b < 1))
+    {
+      int *q = 0;
+
+      if(a)
+	{
+	  c = 0;
+lbl:
+	  for(*d; *d; ++*d)
+	    if(c ? : a ? : (c = 1) ? : 0)
+	      *q &= 1;
+	  return;
+	}
+
+      q = (int *)1;
+    }
+  goto lbl;
+}
+
Index: gcc/testsuite/gcc.dg/pr48186.c
===================================================================
--- gcc/testsuite/gcc.dg/pr48186.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/pr48186.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,5 @@
+/* PR tree-optimization/48186 */
+/* { dg-do compile } */
+/* { dg-options "-O --param hot-bb-frequency-fraction=0" } */
+
+void foo (void) { }
Index: gcc/testsuite/gcc.dg/uninit-pred-5_b.c
===================================================================
--- gcc/testsuite/gcc.dg/uninit-pred-5_b.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.dg/uninit-pred-5_b.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -6,8 +6,9 @@
 int blah(int);
 void t(int);
 
+static int
 __attribute__((always_inline)) 
-int foo (int n, int* v, int r)
+foo (int n, int* v, int r)
 {
   int flag = 0;
   if (r > n)
Index: gcc/testsuite/gcc.dg/const-1.c
===================================================================
--- gcc/testsuite/gcc.dg/const-1.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.dg/const-1.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,4 +1,4 @@
-/* { dg-do compile } */
+/* { dg-do compile { target nonpic } } */
 /* { dg-options "-O2 -Wsuggest-attribute=const" } */
 
 extern int extern_const(int a) __attribute__ ((const));
Index: gcc/testsuite/gcc.dg/pr55702.c
===================================================================
--- gcc/testsuite/gcc.dg/pr55702.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/pr55702.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,9 @@
+/* PR sanitizer/55702 */
+/* { dg-do compile { target { x86_64-*-linux* && lp64 } } } */
+/* { dg-options "-fsanitize=thread" } */
+
+void
+foo ()
+{
+  __builtin_return (0);
+}
Index: gcc/testsuite/gcc.dg/pr56990.c
===================================================================
--- gcc/testsuite/gcc.dg/pr56990.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/pr56990.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,10 @@
+/* PR sanitizer/56990 */
+/* { dg-do compile { target { x86_64-*-linux* && lp64 } } } */
+/* { dg-options "-fsanitize=thread" } */
+
+struct S{};
+
+void foo(struct S *p)
+{
+  *p = (struct S){};
+}
Index: gcc/testsuite/gcc.dg/torture/pr55964-2.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr55964-2.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/torture/pr55964-2.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,21 @@
+/* { dg-do compile } */
+/* { dg-options "-ftree-loop-distribution -funswitch-loops" } */
+
+struct test_struct {
+    int a, b[10], c[10], d[10];
+};
+
+extern struct test_struct* new_struct;
+
+void testfunc(struct test_struct* old_struct)
+{
+  int i;
+  for (i = 0; i < 10; ++i)
+    {
+      new_struct->b[i] = old_struct ? old_struct->b[i] : -1;
+      new_struct->c[i] = old_struct ? old_struct->c[i] : 0;
+      new_struct->d[i] = old_struct ? old_struct->d[i] : 0;
+    }
+  if (old_struct)
+    old_struct->a++;
+}
Index: gcc/testsuite/gcc.dg/torture/pr56501.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr56501.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/torture/pr56501.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,27 @@
+/* { dg-do compile } */
+/* { dg-options "-w" } */
+
+int a;
+void try_help () __attribute__ ((__noreturn__));
+void try_help ()
+{
+}
+
+int main ()
+{
+  switch (a)
+    {
+      case '1':
+      case '2':
+      case '3':
+      case '4':
+      case '5':
+      case '6':
+      case '7':
+      case '8':
+      case '9':
+	  break;
+      default:
+	  try_help ();
+    }
+}
Index: gcc/testsuite/gcc.dg/torture/pr57303.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr57303.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/torture/pr57303.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,33 @@
+/* { dg-do run } */
+
+void abort (void);
+
+struct S0
+{
+  int f0;
+};
+struct S1
+{
+  struct S0 f0;
+};
+
+struct S1 x = { {0} };
+struct S1 y = { {1} };
+
+static void
+foo (struct S0 p)
+{
+  struct S0 *l = &y.f0;
+  *l = x.f0;
+  if (p.f0)
+    *l = *l;
+}
+
+int
+main ()
+{
+  foo(y.f0);
+  if (y.f0.f0 != 0)
+    abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/torture/builtin-logb-1.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/builtin-logb-1.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.dg/torture/builtin-logb-1.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -48,25 +48,25 @@
 /* Test if FUNCRES(FUNC(NEG FUNCARG(ARGARG))) is false.  Check the
    sign as well.  */
 #ifndef __SPU__
-#define TESTIT3(FUNC,NEG,FUNCARG,ARGARG,FUNCRES) do { \
+#define TESTIT3(FUNC,NEG,FUNCARG,ARGARG,FUNCRES,NEG2) do { \
   if (!__builtin_##FUNCRES##f(__builtin_##FUNC(NEG __builtin_##FUNCARG##f(ARGARG))) \
-      || CKSGN_F(__builtin_##FUNC##f(NEG __builtin_##FUNCARG##f(ARGARG)), NEG __builtin_##FUNCARG##f(ARGARG))) \
+      || CKSGN_F(__builtin_##FUNC##f(NEG __builtin_##FUNCARG##f(ARGARG)), NEG2 __builtin_##FUNCARG##f(ARGARG))) \
     link_error(__LINE__); \
   if (!__builtin_##FUNCRES(__builtin_##FUNC(NEG __builtin_##FUNCARG(ARGARG))) \
-      || CKSGN(__builtin_##FUNC(NEG __builtin_##FUNCARG(ARGARG)), NEG __builtin_##FUNCARG(ARGARG))) \
+      || CKSGN(__builtin_##FUNC(NEG __builtin_##FUNCARG(ARGARG)), NEG2 __builtin_##FUNCARG(ARGARG))) \
     link_error(__LINE__); \
   if (!__builtin_##FUNCRES##l(__builtin_##FUNC##l(NEG __builtin_##FUNCARG##l(ARGARG))) \
-      || CKSGN_L(__builtin_##FUNC##l(NEG __builtin_##FUNCARG##l(ARGARG)), NEG __builtin_##FUNCARG##l(ARGARG))) \
+      || CKSGN_L(__builtin_##FUNC##l(NEG __builtin_##FUNCARG##l(ARGARG)), NEG2 __builtin_##FUNCARG##l(ARGARG))) \
     link_error(__LINE__); \
   } while (0)
 #else
-#define TESTIT3(FUNC,NEG,FUNCARG,ARGARG,FUNCRES) do { \
+#define TESTIT3(FUNC,NEG,FUNCARG,ARGARG,FUNCRES,NEG2) do { \
   /* SPU single-precision floating point format does not support Inf or Nan.  */ \
   if (!__builtin_##FUNCRES(__builtin_##FUNC(NEG __builtin_##FUNCARG(ARGARG))) \
-      || CKSGN(__builtin_##FUNC(NEG __builtin_##FUNCARG(ARGARG)), NEG __builtin_##FUNCARG(ARGARG))) \
+      || CKSGN(__builtin_##FUNC(NEG __builtin_##FUNCARG(ARGARG)), NEG2 __builtin_##FUNCARG(ARGARG))) \
     link_error(__LINE__); \
   if (!__builtin_##FUNCRES##l(__builtin_##FUNC##l(NEG __builtin_##FUNCARG##l(ARGARG))) \
-      || CKSGN_L(__builtin_##FUNC##l(NEG __builtin_##FUNCARG##l(ARGARG)), NEG __builtin_##FUNCARG##l(ARGARG))) \
+      || CKSGN_L(__builtin_##FUNC##l(NEG __builtin_##FUNCARG##l(ARGARG)), NEG2 __builtin_##FUNCARG##l(ARGARG))) \
     link_error(__LINE__); \
   } while (0)
 #endif
@@ -173,15 +173,15 @@
 
   /* Test for f(+-Inf) -> +-Inf and f(+-NaN) -> +-NaN, regardless of
      the radix.  */
-  TESTIT3 (logb, ,inf, , isinf);
-  TESTIT3 (logb, - ,inf, , isinf);
-  TESTIT3 (logb,  ,nan, "", isnan);
-  TESTIT3 (logb, - ,nan, "", isnan);
+  TESTIT3 (logb, ,inf, , isinf, );
+  TESTIT3 (logb, - ,inf, , isinf, );
+  TESTIT3 (logb,  ,nan, "", isnan, );
+  TESTIT3 (logb, - ,nan, "", isnan, -);
 
-  TESTIT3 (significand, ,inf, , isinf);
-  TESTIT3 (significand, - ,inf, , isinf);
-  TESTIT3 (significand,  ,nan, "", isnan);
-  TESTIT3 (significand, - ,nan, "", isnan);
+  TESTIT3 (significand, ,inf, , isinf, );
+  TESTIT3 (significand, - ,inf, , isinf, -);
+  TESTIT3 (significand,  ,nan, "", isnan, );
+  TESTIT3 (significand, - ,nan, "", isnan, -);
 }
 
 int main()
Index: gcc/testsuite/gcc.dg/torture/pr57214.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr57214.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/torture/pr57214.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,25 @@
+/* { dg-do compile } */
+
+extern int baz (void);
+extern int foo (void) __attribute__ ((returns_twice));
+
+void
+bar (_Bool b)
+{
+  int buf[1];
+  while (1)
+    {
+      _Bool x = 1;
+      if (b)
+	baz ();
+      b = 1;
+      baz ();
+      x = 0;
+      int i;
+      while (buf[i] && i)
+	i++;
+      foo ();
+      if (!x)
+	b = 0;
+    }
+}
Index: gcc/testsuite/gcc.dg/torture/pr57330.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr57330.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/torture/pr57330.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,11 @@
+/* { dg-do compile } */
+
+void foo (int a)
+{}
+
+void *a;
+void bar ()
+{
+  void **( *b ) (  ) = (void**(*)()) foo;
+  a = b (0);
+}
Index: gcc/testsuite/gcc.dg/torture/pr57251.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr57251.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/torture/pr57251.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,12 @@
+/* PR middle-end/57251 */
+/* { dg-do compile } */
+/* { dg-options "-ftracer" } */
+
+short a, b;
+int
+f (void)
+{
+  long long i = 2;
+  a ? f () ? : 0 : b--;
+  b &= i *= a |= 0;
+}
Index: gcc/testsuite/gcc.dg/torture/pr56407.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr56407.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/torture/pr56407.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,48 @@
+/* { dg-do run } */
+
+extern void abort(void);
+extern int rand(void);
+
+static void copy(int *r,int *a,int na)
+{
+  int i;
+  for( i = 0 ; i < na ; i++ )
+    r[i] = a[i];
+}
+
+static void foo(int *a,int na)
+{
+  int i;
+  for( i = 0 ; i < na ; i++ )
+    a[i] = rand();
+}
+
+static int cmp(int *a,int *b,int n)
+{
+  int i;
+  for( i = 0 ; i < n ; i++ )
+    if ( a[i] != b[i] )
+      return -1;
+  return 0;
+}
+
+void __attribute__((noinline,noclone))
+test(int sz,int comm)
+{
+  int j,n;
+  int v[64],w[64];
+  for( j = 1 ; j <= sz ; j++ )
+    {
+      n = (2 * j - 1) * (2 * j - 1);
+      foo(w,n);
+      copy(v,w,n);
+      if ( comm )
+	if ( cmp(v,w,n) ) abort ();
+    }
+}
+
+int main()
+{
+  test(2,1);
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/torture/pr57083.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr57083.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/torture/pr57083.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,15 @@
+/* PR tree-optimization/57083 */
+/* { dg-do run { target int32plus } } */
+
+extern void abort (void);
+short x = 1;
+int y = 0;
+
+int
+main ()
+{
+  unsigned t = (0x7fff8001U - x) << (y == 0);
+  if (t != 0xffff0000U)
+    abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/tree-ssa/loadpre6.c
===================================================================
--- gcc/testsuite/gcc.dg/tree-ssa/loadpre6.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.dg/tree-ssa/loadpre6.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,4 +1,4 @@
-/* { dg-do compile } */ 
+/* { dg-do compile { target nonpic } } */
 /* { dg-options "-O2 -fdump-tree-pre-stats -fdump-tree-fre1" } */
 #include <stddef.h>
 
Index: gcc/testsuite/gcc.dg/tree-ssa/ipa-split-5.c
===================================================================
--- gcc/testsuite/gcc.dg/tree-ssa/ipa-split-5.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.dg/tree-ssa/ipa-split-5.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,4 +1,4 @@
-/* { dg-do compile } */
+/* { dg-do compile { target nonpic } } */
 /* { dg-options "-O3 -fdump-tree-fnsplit -fdump-tree-optimized" } */
 
 struct a {int a,b;};
Index: gcc/testsuite/gcc.dg/tree-ssa/reassoc-27.c
===================================================================
--- gcc/testsuite/gcc.dg/tree-ssa/reassoc-27.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/tree-ssa/reassoc-27.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,11 @@
+/* { dg-do compile } */
+/* { dg-options "-O -ffast-math -frounding-math -fdump-tree-optimized" } */
+
+double baz (double foo, double bar)
+{
+  return foo * foo * foo * foo * bar * bar * bar * bar;
+}
+
+/* We should re-associate this as (foo * bar)**3.  */
+/* { dg-final { scan-tree-dump-times " \\\* " 3 "optimized" } } */
+/* { dg-final { cleanup-tree-dump "optimized" } } */
Index: gcc/testsuite/gcc.dg/tree-ssa/stdarg-6.c
===================================================================
--- gcc/testsuite/gcc.dg/tree-ssa/stdarg-6.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.dg/tree-ssa/stdarg-6.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -33,3 +33,4 @@
 /* { dg-final { scan-tree-dump "bar: va_list escapes 1, needs to save all GPR units" "stdarg" { target { { i?86-*-* x86_64-*-* } && ia32 } } } } */
 /* { dg-final { scan-tree-dump "bar: va_list escapes 1, needs to save all GPR units" "stdarg" { target ia64-*-* } } } */
 /* { dg-final { scan-tree-dump "bar: va_list escapes 1, needs to save all GPR units" "stdarg" { target { powerpc*-*-* && lp64 } } } } */
+/* { dg-final { cleanup-tree-dump "stdarg" } } */
Index: gcc/testsuite/gcc.dg/pr56890-1.c
===================================================================
--- gcc/testsuite/gcc.dg/pr56890-1.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/pr56890-1.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,15 @@
+/* PR target/56890 */
+/* Reported by Rainer Jung <rainer.jung@kippdata.de> */
+
+/* { dg-do assemble } */
+/* { dg-options "-O2" } */
+
+unsigned int buggy(unsigned int min, unsigned int max)
+{
+    if (max < 16384) {
+        unsigned short num16 = 0;
+        num16 = min + (long) ((double) (max - min + 1.0) * (num16 / (65535 + 1.0)));
+        return num16;
+    }
+    return 0;
+}
Index: gcc/testsuite/gcc.dg/ipa/pr56988.c
===================================================================
--- gcc/testsuite/gcc.dg/ipa/pr56988.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/ipa/pr56988.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,38 @@
+/* { dg-do run } */
+/* { dg-options "-O3" } */
+/* { dg-add-options bind_pic_locally } */
+
+struct S
+{
+  int a, b, c;
+};
+
+volatile int g;
+
+static void __attribute__ ((noinline, noclone))
+bar (struct S **p)
+{
+  g = 5;
+};
+
+static void __attribute__ ((noinline))
+foo (struct S *p)
+{
+  int i = p->a;
+  if (i != 1)
+    __builtin_abort ();
+  bar (&p);
+}
+
+int
+main (int argc, char *argv[])
+{
+  struct S s;
+  s.a = 1;
+  s.b = 64;
+  s.c = 32;
+  foo (&s);
+
+  return 0;
+}
+
Index: gcc/testsuite/gcc.dg/ipa/pure-const-1.c
===================================================================
--- gcc/testsuite/gcc.dg/ipa/pure-const-1.c	(.../tags/gcc_4_8_0_release)	(revision 199208)
+++ gcc/testsuite/gcc.dg/ipa/pure-const-1.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -1,4 +1,4 @@
-/* { dg-do compile } */
+/* { dg-do compile { target nonpic } } */
 /* { dg-options "-O3 -fdump-tree-local-pure-const1 -fdump-ipa-pure-const -fdump-tree-optimized -fno-early-inlining" } */
 void abort (void);
 int error_code;
Index: gcc/testsuite/gcc.dg/vect/pr56920.c
===================================================================
--- gcc/testsuite/gcc.dg/vect/pr56920.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/vect/pr56920.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,21 @@
+/* PR tree-optimization/56920 */
+/* { dg-additional-options "-O3" } */
+
+#include "tree-vect.h"
+
+extern void abort (void);
+
+int
+main ()
+{
+  unsigned int a[15], i;
+  check_vect ();
+  for (i = 0; i < 15; ++i)
+    a[i] = (i * 2) % 15;
+  for (i = 0; i < 15; ++i)
+    if (a[i] != (i * 2) % 15)
+      abort ();
+  return 0;
+}
+
+/* { dg-final { cleanup-tree-dump "vect" } } */
Index: gcc/testsuite/gcc.dg/vect/pr56918.c
===================================================================
--- gcc/testsuite/gcc.dg/vect/pr56918.c	(.../tags/gcc_4_8_0_release)	(revision 0)
+++ gcc/testsuite/gcc.dg/vect/pr56918.c	(.../branches/gcc-4_8-branch)	(revision 199208)
@@ -0,0 +1,31 @@
+/* PR tree-optimization/56918 */
+/* { dg-additional-options "-O3" } */
+
+#include "tree-vect.h"
+
+extern void abort (void);
+double data[8];
+
+__attribute__((noinline, noclone)) void
+foo ()
+{
+  int i;
+  for (i = 0; i < 8; ++i)
+    data[i] = ((i + 2) % 3) + 1;
+}
+
+int
+main ()
+{
+  int i;
+  check_vect ();
+  foo ();
+  if (data[0] != 3 || data[7] != 1)
+    abort ();
+  for (i = 1; i < 4; ++i)
+    if (data[i] != i || data[i + 3] != i)
+      abort ();
+  return 0;
+}
+
+/* { dg-final { cleanup-tree-dump "vect" } } */
